/*
 * Copyright 2020 Adler Neves.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package br.ufes.inf.decisionelement.gana.networkprofile.goal;

import br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.MathExpressionException;
import br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.MathExpressionParser;
import br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.syntaxtree.MathTreeContext;
import br.ufes.inf.decisionelement.wheelreinventions.json.JsonString;

/**
 * No docstring set.
 */
public class NetworkGoal {
    MathTreeContext contextualizedGoalOriginal;
    MathTreeContext contextualizedGoal;
    public NetworkGoal() {
    }
    public NetworkGoal(MathTreeContext tree) throws MathExpressionException {
        contextualizedGoalOriginal = tree;
        contextualizedGoal = tree.getSimplified();
    }
    public static NetworkGoal deJson(JsonString jsonString)
            throws MathExpressionException, NetworkProfileGoalException {
        MathTreeContext tree = MathExpressionParser.makeTree(jsonString.getRepresentation());
        if (tree.getSimplified().decontextualized().isConstant()) {
            throw new NetworkProfileGoalException();
        }
        return new NetworkGoal(tree);
    }
}
