/*
 * Copyright 2020 Adler Neves.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.syntaxtree;

import br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.MathExpressionException;
import br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.syntaxtree.operations.TreeFindReplace;

/**
 * No docstring set.
 */
public class MathTreeOperandNested extends MathTreeOperand<MathTree<?>> {
    public MathTreeOperandNested() throws MathExpressionException {
        super();
    }
    public MathTreeOperandNested(MathTree<?> t) throws MathExpressionException {
        super(t);
    }
    @Override
    public String toString() {
        return "" + data;
    }
    @Override
    public MathTree<?> getSimplified() throws MathExpressionException {
        return data.getSimplified();
    }
    @Override
    public boolean isConstant() {
        return data.isConstant();
    }
    @Override
    public MathTree<?> replaceInner(TreeFindReplace findReplace) throws MathExpressionException {
        return new MathTreeOperandNested(data.replace(findReplace));
    }
}
