/*
 * Copyright 2020 Adler Neves.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.syntaxtree;

import br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.MathExpressionException;
import br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.syntaxtree.operations.TreeFindReplace;

/**
 * No docstring set.
 */
public abstract class MathTreeOperandValue<T> extends MathTreeOperand<T> {
    public MathTreeOperandValue() throws MathExpressionException {
        super();
    }
    public MathTreeOperandValue(T t) throws MathExpressionException {
        super(t);
    }
    public MathTree<?> replace(TreeFindReplace findReplace) throws MathExpressionException {
        if (findReplace.toBeFound.equals(this)) {
            return findReplace.toBeReplaced;
        } else {
            return this;
        }
    }
    @Override
    public MathTree<?> replaceInner(TreeFindReplace findReplace) throws MathExpressionException {
        throw new UnsupportedOperationException("MathTreeOperandValue has no inner tree.");
    }
}
