/*
 * Copyright 2020 Adler Neves.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.syntaxtree;

import br.ufes.inf.decisionelement.wheelreinventions.expressionparsing.MathExpressionException;
import br.ufes.inf.decisionelement.wheelreinventions.positionalcollections.Tuple;

/**
 * No docstring set.
 */
public class MathTreeOperatorBinMul extends MathTreeOperatorBin<MathTree<?>, MathTree<?>> {
    public MathTreeOperatorBinMul() throws MathExpressionException {
        super();
    }
    public MathTreeOperatorBinMul(Tuple<MathTree<?>, MathTree<?>> c) throws MathExpressionException {
        super(c);
    }
    @Override
    protected char getOperatorSymbol() {
        return '*';
    }
    @Override
    protected double doTheMath(double l1, double l2) {
        return l1 * l2;
    }
    @Override
    protected MathTreeOperatorBin
        selfBuildModifiedFrom(Tuple<MathTree<?>, MathTree<?>> t)
            throws MathExpressionException {
        return new MathTreeOperatorBinMul(t);
    }
}
